function V=oc_solveLQG(M,J);
% function V=oc_solveLQG(M,J);
% calculates the optimal-cost-to go Matrix (V)
% Given a system (M) and a cost function (J)
% System is:
% dynamics:  x_t+1 = A x_t + B u_t + epsilon
% sensory:   y_t = H x_t+1 + omega
% Cost function:
% Local cost: x'Qx + u'Ru
%
% The matrices A & B can be defined as time dependent if they are 3-dimensional
% Joern Diedrichsen j.diedrichsen@bangor.ac.uk
N=size(J.Q,3);
V(:,:,N)=J.Q(:,:,N);
for n=N-1:-1:1
    if (length(size(M.B))==2)
        B=M.B;
    else
        B=M.B(:,:,n);
    end;
    if (length(size(M.A))==2)
        A=M.A;
    else
        A=M.A(:,:,n);
    end;
    L(:,:,n)=inv(B'*V(:,:,n+1)*B+J.R)*B'*V(:,:,n+1)*A;
    V(:,:,n)=J.Q(:,:,n)+A'*V(:,:,n+1)*A-A'*V(:,:,n+1)*B*L(:,:,n);
end;